; bash emulation (sort of) , dtiazlovas@alna.lt
   
use32
   
; Supported commands (alphabetical list):
;
; cls - clears screen
; exit - close mash
; kill pid - kill process with specified id
; ls - list rd dirs/files (-s for short listing (default), -l for long listing)
; ps - process list
; quit - close mash
; ver - version info
; shutdown - quit menuet
;
; if the command entered is not any of the ones above,
; shell will try to run the rd file with that name.
   
 org 0x0
   
 db 'MENUET01'
 dd 0x01
 dd START
 dd I_END
 dd 0x80000
 dd 0x7fff0
 dd 0x0,0x0
   
START:
 call set_variables
 mov ebx, prompt
 call printf
 call red
still:
 mov eax, 10     ; wait for event
 int 0x40
   
 cmp eax, 1      ; redraw?
 je  re
 cmp eax, 2      ; keypress?
 je key
 cmp eax, 3
 je button       ; button?
   
 jmp still
   
re:
 call red
 jmp  still
   
red:
 pusha
 call draw_window
 popa
 ret
   
red1:
 pusha
 call draw_window1
 popa
 ret
   
key:
 mov eax, 2
 int 0x40
 shr eax, 8
 cmp al, 178     ; arrow up
 jne noaup
 jmp historyup
noaup:
 cmp al, 177     ; arrow down
 jne noadown
 jmp historydown
   
noadown:
 cmp al, 179     ; arrow right
 jne noaright
 mov al, 'D'
 call arrow
 jmp still
noaright:
 cmp al, 176     ; arrow left
 jne noaleft
 mov al, 'A'
 call arrow
 jmp still
noaleft:
 cmp al, 180     ; home
 jne nohome
 mov [posx], proend-prompt-1
 call red1
 jmp still
nohome:
 cmp al, 181     ; end
 jne noendkey
 mov ebx, [cols]
 dec ebx
 mov [posx], ebx
 call red1
 jmp still
noendkey:
 cmp al, 182     ; del
 je delkey
 cmp al, 8       ; backspace
 je bskey
 cmp al, 27      ; escape
 jne noescape
 xor eax, eax
 dec eax
 int 0x40
noescape:
 cmp al, 13      ; enter
 jne noenter
 cmp [captured],1
 jne no_capture
 jmp stdin_ret
no_capture:
 jmp exec_command
noenter:
 cmp al, ' '
 jl badkey
 cmp al, '~'
 jg badkey
   
 ;mov [symbol], al
 ;mov ebx, symbol
 ;call printf
 ;xor eax, eax
 ;call red
   
 push eax
 mov eax, [posy]
 mov ebx, eax
 shl eax, 2
 add ebx, eax
 shl ebx, 4
 add ebx, [posx]
 add ebx, [con1off]
 mov al, ' '
 mov ecx, [cols]
 sub ecx, [posx]
 dec ecx
 push ecx
 mov edi, ebx
 cld
 repz scasb
 cmp ecx, 0
 jnz insertmode
 pop ecx
writekey:
 pop eax
 mov [ebx], al
 sub ebx, [con1off]
 add ebx, [con2off]
 mov byte [ebx], 1
 inc dword [posx]
 mov eax, [cols]
 cmp eax, [posx]
 jg noxjump
 dec dword [posx]
noxjump:
 mov ecx, [cols]
 sub ecx, [posx]
 dec ecx
 mov al, 1
 mov edi, ebx
 cld
 repz stosb
 call red1
 jmp still
insertmode:
 pop ecx
 push ebx
 add ebx, ecx
 mov esi, ebx
 mov edi, ebx
 dec esi
 std
 rep movsb
 pop ebx
 jmp writekey
   
badkey:
 jmp still
   
button:
 mov eax, 17     ; get button id
 int 0x40
 cmp ah, 1
 jne noclose
 xor eax, eax
 dec eax
 int 0x40
noclose:
 jmp still
   
historyup:
 jmp still
historydown:
 jmp still
   
arrow:
 cmp al,'A'
 jne rightarrow
 mov eax, proend-prompt
 cmp [posx], eax
 jl arrowend
 dec [posx]
 call red1
 jmp arrowend
rightarrow:
 mov ebx, [cols]
 cmp [posx], ebx
 jnl arrowend
 inc [posx]
 call red1
arrowend:
 ret
   
   
delkey:
 mov eax, [posx]
 inc eax
 cmp eax, [cols]
 jge delkeyend
 mov eax, [posy]
 mov esi, eax
 shl eax, 2
 add esi, eax
 shl esi, 4
 add esi, [posx]
 add esi, [con1off]
 inc esi
 mov ecx, [cols]
 sub ecx, [posx]
 dec ecx
 mov edi, esi
 dec edi
 push esi
 push ecx
 cld
 rep movsb
 pop ecx
 pop edi
 add edi, 80*25
 mov al, 1
 push edi
 cld
 rep stosb
 pop edi
 sub edi, [posx]
 add edi, [cols]
 mov byte [edi-1], ' '
 call red1
delkeyend:
 jmp still
   
bskey:
 mov eax, proend-prompt-1
 cmp [posx], eax
 jle nobskey
 dec [posx]
 jmp delkey
 call red1
nobskey:
 jmp still
   
set_variables:
 mov ebx, con2
 mov [con1off], ebx
 add ebx, 80*25
 mov [con2off], ebx
 add ebx, 80*25
 mov [int_list], ebx
 mov esi, con2
 mov edi, esi
 mov ecx, 500
 mov eax, '    '
 pusha
 cld
 rep stosd
 popa
 add esi, 80*25
 mov edi, esi
 mov eax, 0x01010101
 cld
 rep stosd
 ret
   
exec_command:
 mov eax, [posy]
 mov esi, eax
 shl esi, 2
 add esi, eax
 shl esi, 4
 add esi, [con1off]
 add esi, proend-prompt-1
 mov edi, esi
 mov al, ' '
 mov ecx, [cols]
 sub ecx, proend-prompt-1
el1:
 cmp byte [edi], al
 je fs1
 inc edi
 loop el1
fs1:
 mov byte [edi], 0
 call find_proc
 mov byte [edi], ' '
 cmp byte [curcmd], 0    ; cls
 jne np_cls
 call set_variables
 mov dword [posy], 0
 jmp ec_end
np_cls:
 cmp byte [curcmd], 1    ; exit
 jne np_exit
 mov eax, -1
 int 0x40
np_exit:
 cmp byte [curcmd], 2    ; quit
 jne np_quit
 mov eax, -1
 int 0x40
np_quit:
 cmp byte [curcmd], 3    ; shutdown
 jne np_shutdown
 mov eax, 18
 mov ebx, 1
 int 0x40
np_shutdown:
free_cmd:
 mov eax, [posy]
 mov ebx, eax
 shl ebx, 2
 add ebx, eax
 shl ebx, 4
 add ebx, [con1off]
 add ebx, proend-prompt-1
   
 call start_elf
   
 mov ebx, file_name
 mov ecx, 0
 mov eax, 19
 int 0x40
 cmp eax,0xfffffff0
 jb ec_end
 ;cmp eax, 0
 ;jnz filenotfound
 ;jmp ec_end
filenotfound:
 mov ebx, cmd_err
 call printf
ec_end:
 mov ebx, prompt
 call printf
 call red1
 jmp still
   
find_proc:
 push edi
 push esi
 mov byte [curcmd], -1
 mov eax, cmd_end-cmd_table
 shr eax, 2
 mov ecx, eax
 mov ebx, cmd_table
fploop:
 mov edi, [ebx]
 call strzcmp
 cmp [strez], 0
 jnz fpok
 add ebx, 4
 loop fploop
 jmp fp_end
fpok:
 sub ebx, cmd_table
 shr ebx, 2
 mov [curcmd], bl
fp_end:
 pop esi
 pop edi
 ret
   
   
strzcmp:
 pusha
 mov byte [strez], 1
cmploop:
 mov al, [esi]
 mov bl, [edi]
 cmp al, bl
 je cmpok
 cmp al, 0
 jnz cmpend1
 cmp bl, 0
 jnz cmpend1
 jmp cmpend
cmpend1:
 mov byte [strez], 0
cmpok:
 cmp al, 0
 jz cmpend
 inc edi
 inc esi
 jmp cmploop
cmpend:
 popa
 ret
   
   
   
;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************
   
   
draw_window:
   
    mov [fredraw],1                ; DRAW WINDOW
    mov  eax,12
    mov  ebx,1
    int  0x40
   
    mov  eax,0
    mov  ebx,100*65536+491 ;87
    mov  ecx,100*65536+280 ;76
    mov  edx,[wcolor]
    mov  esi,0x80999999
    mov  edi,0x00999999
    int  0x40
   
       ; WINDOW LABEL
    mov  eax,4
    mov  ebx,8*65536+8
    mov  ecx,0x00ffffff
    mov  edx,labelt
    mov  esi,labellen-labelt
    int  0x40
   
       ; CLOSE BUTTON
    mov  eax,8
    mov  ebx,(491-19)*65536+12
    mov  ecx,5*65536+12
    mov  edx,1
    mov  esi,0x999999
    int  0x40
   
    mov  eax,12
    mov  ebx,2
    int  0x40
   
    call draw_text
   
    ret
   
   
bgc  dd  0x000000
     dd  0x000000
     dd  0x00ff00
     dd  0x0000ff
     dd  0x005500
     dd  0xff00ff
     dd  0x00ffff
     dd  0x770077
   
tc   dd  0xffffff
     dd  0xff00ff
     dd  0xffffff
     dd  0xffffff
     dd  0xffffff
     dd  0xffffff
     dd  0xffffff
     dd  0xffffff
   
   
   
draw_window1:
    mov [fredraw],0
    call draw_text
    ret
   
   
   
draw_text:
 pusha
 mov esi, [con1off]
 mov [curline], 0
 mov [cury], 0
 mov [isactive], 0
new_line:
 mov [curx], 0
 mov edx, 0
next_letter:
 add edx, esi
 call draw_letter
 mov [isactive], 0
 sub edx, esi
 inc edx
 cmp edx, [cols]
 jge next_line
 inc [curx]
 jmp next_letter
next_line:
 add esi, [cols]
 inc [curline]
 mov eax, [lines]
 cmp [curline], eax
 jge all_done
 inc [cury]
 jmp new_line
all_done:
 mov eax, [posx]
 mov [oldx], eax
 mov eax, [posy]
 mov [oldy], eax
 popa
 ret
   
draw_letter:
; input:
;   edx - letter address
 pusha
 xor eax, eax
 cmp byte [edx+80*25], 0
 jz lta1
 inc eax
lta1:
 mov ebx, [oldx]
 cmp [curx], ebx
 jne lta2
 mov ebx, [oldy]
 cmp [cury], ebx
 jne lta2
 inc eax
lta2:
 mov ebx, [posx]
 cmp ebx, [curx]
 jne lta3
 mov ebx, [posy]
 cmp ebx, [cury]
 jne lta3
 inc eax
lta3:
 cmp [fredraw], 0
 jz lta4
 inc eax
lta4:
 cmp eax, 0
 jz letter_space
 call draw_letter_back
 mov al, [edx]
 cmp al, ' '
 je letter_space
 call transfer_current
 mov ebx, [curx1]
 shl ebx, 16
 add ebx, [cury1]
 xor ecx, ecx
 cmp [isactive], 0
 jz normal_letter
 mov ecx, 0x00E0E0E0
normal_letter:
 mov esi, 1
 mov eax, 4
 push edx
 int 0x40
 pop edx
 mov byte [edx+80*25], 0
letter_space:
 popa
 ret
   
transfer_current:
 mov eax, [curx]
 mov ebx, eax
 shl ebx, 1
 add ebx, eax
 shl ebx, 1
 add ebx, 6  ;3
 mov [curx1], ebx
 mov eax, [cury]
 mov ebx, eax
 shl ebx, 3
 add ebx, eax
 add ebx, eax
 add ebx, 23
 mov [cury1], ebx
 ret
   
draw_letter_back:
 pusha
 call transfer_current
 xor eax, eax
 mov ebx, [curx]
 cmp ebx, [posx]
 jne no_posx_match
 inc eax
no_posx_match:
 mov ebx, [curx1]
 shl ebx, 16
 add ebx, 6
   
 mov ecx, [cury]
 cmp ecx, [posy]
 jne no_posy_match
 inc eax
no_posy_match:
 mov ecx, [cury1]
 shl ecx, 16
 add ecx, 10
 mov edx, 0x00C0C0D0
 cmp eax, 2
 jne no_both_match
 mov edx, 0x00101018
 mov [isactive], 1
no_both_match:
 mov eax, 13
 int 0x40
 popa
 ret
   
printf:
; input:
;   ebx - zstring
 pusha
str_loop:
 mov dl, [ebx]
 cmp dl, 0       ; are we done?!
 jz str_end
 cmp dl, 13      ; CR
 je do_CR
 mov ecx, [posy]
 mov esi, ecx
 shl esi, 2
 add esi, ecx
 shl esi, 4
 add esi, [posx]
 add esi, [con1off]
 mov [esi], dl
 add esi, 80*25
 mov byte [esi], 1
 inc [posx]
 mov eax, [cols]
 cmp [posx], eax
 jnl do_CR
 inc ebx
 inc [posch]
 jmp str_loop
do_CR:
 mov [posx], 0
 inc [posy]
 inc ebx
 inc [posch]
 mov eax, [lines]
 cmp eax, [posy]
 je do_scrl
 jmp str_loop
do_scrl:
 call scrollup
 mov dword [posx], 0
 dec dword [posy]
 jmp str_loop
str_end:
 popa
 ret
   
scrollup:
 pusha
 mov edi, [con1off]
 mov esi, edi
 add esi, [cols]
 mov ecx, 80*24
 cld
 rep movsb
 mov edi, [con1off]
 add edi, 80*24
 mov ecx, [cols]
 shr ecx, 2
 mov eax, '    '
 cld
 rep stosd
 mov edi, [con2off]
 mov ecx, 80*25
 shr ecx, 2
 mov eax, 0x01010101
 cld
 rep stosd
 dec [capture_posy]
 popa
 ret
   
   
int_0x80:
 pusha
 cmp eax, 1
 jne no_stdout
 call printf
 call red1
 popa
 int  0x80
 jmp  int_0x80
no_stdout:
 cmp eax, 2
 jne no_stdin
 call red1
 mov [capture_lock], ebx
 mov [capture_len], ecx
 mov [captured], 1
 mov eax, [posx]
 mov [capture_posx], eax
 mov eax, [posy]
 mov [capture_posy], eax
 jmp still
 popa
 int  0x80
 jmp  int_0x80
stdin_ret:
 mov ebx, empty_line
 call printf
 mov eax, [capture_posy]
 mov ebx, eax
 shl eax, 2
 add ebx, eax
 shl ebx, 4
 add ebx, [capture_posx]
 add ebx, [con1off]
 mov esi, ebx
 mov edi, [capture_lock]
 mov ecx, [capture_len]
 cld
 rep movsb
 call red1
 mov [captured], 0
 popa
 int  0x80
 jmp  int_0x80
no_stdin:
 cmp eax, 2
 jne no_stdpars
 popa
 mov ebx, [int_rez1]
 int  0x80
 jmp  int_0x80
no_stdpars:
 popa
 int  0x80
 jmp  int_0x80
   
   
start_elf:
 pusha
 mov esi,file_name
 mov ecx, 11
 mov eax, '    '
 mov [esi], eax
 mov [esi+4], eax
 mov [esi+8], eax
file_name_loop:
 mov al, [ebx]
 cmp al,' '
 je all_file_name
 cmp al,'a'
 jl  ok_ch
 add al,-32
ok_ch:
 mov [esi], al
 inc esi
 inc ebx
 loop file_name_loop
all_file_name:
 mov [int_rez1], ebx
 mov esi, 0x4000
 mov [esi], dword 0
 call load_elf
 mov esi,0x4000
 cmp [esi], dword 'MENU'
 jne badelf
 cmp [esi+4], dword 'ET02'
 jne badelf
 add esi, 8
 call esi
 pop eax
 popa
 jmp ec_end
badelf:
 popa
 ret
   
   
load_elf:
    pusha
    mov  eax,6
    mov  ebx,file_name
    mov  ecx,0
    mov  edx,-1
    mov  esi,0x4000
    int  0x40
   
    mov  eax,int_0x80
    mov  edi,[int_list]
    mov  ecx,0x100
    cld
    rep  stosd
   
    mov  eax,49         ; define apps interrupt handlers
    mov  ebx,0
    mov  ecx,[int_list]
    int  0x40
    popa
    ret
   
   
   
; DATA AREA
   
captured dd 0
capture_lock dd 0
capture_len dd 0
capture_posx dd 0
capture_posy dd 0
   
int_list dd 0
   
attribute dd 0
scroll dd 1
 dd 24
   
numtext db '                        '
   
wcolor dd 0x02C0C0D0
   
labelt db 'MASH 0.01'
labellen:
   
prompt db 13,'mash',26,' '
proend db 0
   
curcmd db 0
   
posx dd 0
posy dd 0
posch dd 0
oldx dd 0
oldy dd 0
lines dd 25
cols dd 80
   
con1off dd 0
con2off dd 0
   
strez db 0
   
curline dd 0
curx dd 0
cury dd 0
curx1 dd 0
cury1 dd 0
fredraw dd 0
isactive dd 0
redbusy dd 0
   
cmd_table:
  cmd0 dd com0
  cmd1 dd com1
  cmd2 dd com2
  cmd3 dd com3
cmd_end:
   
com_table:
  com0 db 'cls',0
  com1 db 'exit',0
  com2 db 'quit',0
  com3 db 'shutdown',0
com_end:
   
symbol db 0,0
   
int_rez1 dd 0
   
ver_info db 13,'MASH - bash emulator for Menuet',13,'version 0.0.1 build 137'
 db 13,0
   
empty_line db 13,0
cmd_err db 13,'Bad command or file name.',13,0
   
elfok dd 0
   
file_name db 'TTEST      '
   
cool db 'woohoo!',13,0
   
I_END:
   
con2:
   
   
   